Pro test
    fname_lut='./AboveRrs_gCoef_w10.dat'
    th0=85 ; 0-85 degree
    th=87.5  ;0-87.5 degree
    dphi=172.5 ; 0-180 degree
    gb=0.99 ;0-0.99
    coefs=getgCoefs(th0, th, dphi, gb, fname_lut)
    print, coefs
End

Function getGridIndex, grids, var, pos=pos
    ngrid=n_elements(grids)
    igrid=-1
    for i=0, ngrid-2 do begin
       if (var ge grids(i)) and (var le grids(i+1)) then begin
         igrid=i
         break
       endif
    endfor
    if igrid eq -1 then begin
        print, 'invalid var in get GridIndex!'
        return, igrid
    endif
    if  (var gt grids(ngrid-1)) then igrid=ngrid-2
    pos=(var-grids(igrid))/(grids(igrid+1)-grids(igrid))
    return, igrid
End

Function getgCoefs, th0, th, dphi, gb, fname_lut
    readLut, fname_lut, RM, gCoef_lut, ngb, nth0, nth, nphi, gb_lut, th0_lut, th_lut,phi_lut

    igbm=getGridIndex( gb_lut, gb, pos=r_gb)
    ith0m=getGridIndex( th0_lut, th0, pos=r_th0)
    ithm=getGridIndex( th_lut, th, pos=r_th)
    iphim=getGridIndex( phi_lut, dphi, pos=r_phi)
    ;print, igbm, ith0m, ithm, iphim, r_gb, r_th0, r_th, r_phi
    ;print, gCoef_lut[*,igbm+1, iphim, ithm, ith0m]

    gCoeftmp=fltarr(4,2, 2, 2)
    for i=0, 1 do begin
       ith0=ith0m+i
       for j=0, 1 do begin
         ith=ithm+j
         for k=0, 1 do begin
          iphi=iphim+k
          for iord=0, 3 do $
          gCoeftmp[iord, k, j,i]=(1-r_gb)*gCoef_lut[iord,igbm,iphi,ith,ith0]   $
             +r_gb*gCoef_lut[iord,igbm+1,iphi,ith,ith0]
         endfor
       endfor
    endfor


    gCoeftmp1=fltarr(4, 2, 2)
    for i=0, 1 do begin
       for j=0, 1 do begin
         for iord=0, 3 do $
         gCoeftmp1[iord, j,i]=(1-r_phi)*gCoeftmp[iord,0,j,i]   $
                 +r_phi*gCoeftmp[iord,1,j,i]
         endfor
    endfor

    gCoeftmp2=fltarr(4, 2)
    for i=0, 1 do begin

         for iord=0, 3 do $
         gCoeftmp2[iord, i]=(1-r_th)*gCoeftmp1[iord,0,i]   $
                 +r_th*gCoeftmp1[iord,1,i]

    endfor

    gCoef=fltarr(4)
    for iord=0, 3 do $
         gCoef[iord]=(1-r_th0)*gCoeftmp2[iord,0]   $
                 +r_th0*gCoeftmp2[iord,1]

    return, gCoef
End

